# Interface PrimitiveIterator.OfLong

All Superinterfaces:
  `Iterator<Long>, PrimitiveIterator<Long, LongConsumer>`

Enclosing interface:
  `PrimitiveIterator<T,T_CONS>`

public static interface PrimitiveIterator.OfLong extends PrimitiveIterator<Long, LongConsumer>
An Iterator specialized for `long` values.

Since:
  1.8

- ## Nested Class Summary

  ### Nested classes/interfaces declared in interface PrimitiveIterator

  `PrimitiveIterator.OfDouble, PrimitiveIterator.OfInt, PrimitiveIterator.OfLong`
  Modifier and Type
  Interface
  Description
  `static interface`
  `PrimitiveIterator.OfDouble`
  An Iterator specialized for `double` values.
  `static interface`
  `PrimitiveIterator.OfInt`
  An Iterator specialized for `int` values.
  `static interface`
  `PrimitiveIterator.OfLong`
  An Iterator specialized for `long` values.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default void`
  `forEachRemaining(Consumer<? super Long> action)`
  Performs the given action for each remaining element until all elements have been processed or the action throws an exception.
  `default void`
  `forEachRemaining(LongConsumer action)`
  Performs the given action for each remaining element until all elements have been processed or the action throws an exception.
  `default Long`
  `next()`
  Returns the next element in the iteration.
  `long`
  `nextLong()`
  Returns the next `long` element in the iteration.

  ### Methods declared in interface Iterator

  `hasNext, remove`
  Modifier and Type
  Method
  Description
  `boolean`
  `hasNext()`
  Returns `true` if the iteration has more elements.
  `default void`
  `remove()`
  Removes from the underlying collection the last element returned by this iterator (optional operation).

- ## Method Details

  - ### nextLong

    long nextLong()
    Returns the next `long` element in the iteration.
    Returns:
      the next `long` element in the iteration
    Throws:
      `NoSuchElementException` - if the iteration has no more elements

  - ### forEachRemaining

    default void forEachRemaining(LongConsumer action)
    Performs the given action for each remaining element until all elements have been processed or the action throws an exception. Actions are performed in the order of iteration, if that order is specified. Exceptions thrown by the action are relayed to the caller.

    The behavior of an iterator is unspecified if the action modifies the source of elements in any way (even by calling the `remove` method or other mutator methods of `Iterator` subtypes), unless an overriding class has specified a concurrent modification policy.

    Subsequent behavior of an iterator is unspecified if the action throws an exception.

    Specified by:
      `forEachRemaining` in interface `PrimitiveIterator<Long, LongConsumer>`
    Implementation Requirements:

      The default implementation behaves as if:

              while (hasNext())
                  action.accept(nextLong());

    Parameters:
      `action` - The action to be performed for each element

  - ### next

    default Long next()
    Returns the next element in the iteration.
    Specified by:
      `next` in interface `Iterator<Long>`
    Implementation Requirements:
      The default implementation boxes the result of calling `nextLong()`, and returns that boxed result.
    Returns:
      the next element in the iteration

  - ### forEachRemaining

    default void forEachRemaining(Consumer<? super Long> action)
    Performs the given action for each remaining element until all elements have been processed or the action throws an exception. Actions are performed in the order of iteration, if that order is specified. Exceptions thrown by the action are relayed to the caller.

    The behavior of an iterator is unspecified if the action modifies the collection in any way (even by calling the `remove` method or other mutator methods of `Iterator` subtypes), unless an overriding class has specified a concurrent modification policy.

    Subsequent behavior of an iterator is unspecified if the action throws an exception.

    Specified by:
      `forEachRemaining` in interface `Iterator<Long>`
    Implementation Requirements:
      If the action is an instance of `LongConsumer` then it is cast to `LongConsumer` and passed to `forEachRemaining(LongConsumer)`; otherwise the action is adapted to an instance of `LongConsumer`, by boxing the argument of `LongConsumer`, and then passed to `forEachRemaining(LongConsumer)`.
    Parameters:
      `action` - The action to be performed for each element